package com.jxdinfo.hussar.core.bouncycastle.asn1.x9;

package .tmp;

import com.jxdinfo.hussar.core.bouncycastle.asn1.ASN1Encodable;
import com.jxdinfo.hussar.core.bouncycastle.asn1.ASN1Sequence;
import com.jxdinfo.hussar.core.bouncycastle.asn1.DERObject;
import com.jxdinfo.hussar.core.bouncycastle.asn1.DERObjectIdentifier;
import com.jxdinfo.hussar.core.bouncycastle.asn1.x9.X9FieldID;
import com.jxdinfo.hussar.core.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import com.jxdinfo.hussar.core.bouncycastle.math.ec.ECCurve;
import com.jxdinfo.hussar.core.util.PingYinUtil;

public class X9Curve extends ASN1Encodable implements X9ObjectIdentifiers {
  private byte[] C;
  
  private DERObjectIdentifier e = null;
  
  private ECCurve finally;
  
  public X9Curve(X9FieldID x9FieldID, ASN1Sequence aSN1Sequence) {
    // Byte code:
    //   0: aload_1
    //   1: aload_0
    //   2: dup_x1
    //   3: dup_x2
    //   4: aconst_null
    //   5: aload_0
    //   6: invokespecial <init> : ()V
    //   9: putfield e : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObjectIdentifier;
    //   12: invokevirtual getIdentifier : ()Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObjectIdentifier;
    //   15: putfield e : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObjectIdentifier;
    //   18: getfield e : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObjectIdentifier;
    //   21: getstatic com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9Curve.prime_field : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1ObjectIdentifier;
    //   24: invokevirtual equals : (Ljava/lang/Object;)Z
    //   27: ifeq -> 113
    //   30: aload_1
    //   31: invokevirtual getParameters : ()Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObject;
    //   34: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/DERInteger
    //   37: invokevirtual getValue : ()Ljava/math/BigInteger;
    //   40: astore_3
    //   41: new com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9FieldElement
    //   44: dup
    //   45: aload_3
    //   46: aload_2
    //   47: iconst_0
    //   48: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   51: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/ASN1OctetString
    //   54: invokespecial <init> : (Ljava/math/BigInteger;Lcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1OctetString;)V
    //   57: astore #4
    //   59: new com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9FieldElement
    //   62: dup
    //   63: aload_3
    //   64: aload_2
    //   65: iconst_1
    //   66: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   69: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/ASN1OctetString
    //   72: invokespecial <init> : (Ljava/math/BigInteger;Lcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1OctetString;)V
    //   75: astore #5
    //   77: aload_2
    //   78: new com/jxdinfo/hussar/core/bouncycastle/math/ec/ECCurve$Fp
    //   81: aload_0
    //   82: dup_x1
    //   83: dup
    //   84: pop2
    //   85: dup
    //   86: aload_3
    //   87: aload #4
    //   89: invokevirtual getValue : ()Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   92: invokevirtual toBigInteger : ()Ljava/math/BigInteger;
    //   95: aload #5
    //   97: invokevirtual getValue : ()Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   100: invokevirtual toBigInteger : ()Ljava/math/BigInteger;
    //   103: invokespecial <init> : (Ljava/math/BigInteger;Ljava/math/BigInteger;Ljava/math/BigInteger;)V
    //   106: putfield finally : Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECCurve;
    //   109: goto -> 338
    //   112: pop
    //   113: aload_0
    //   114: getfield e : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObjectIdentifier;
    //   117: getstatic com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9Curve.characteristic_two_field : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1ObjectIdentifier;
    //   120: invokevirtual equals : (Ljava/lang/Object;)Z
    //   123: ifeq -> 337
    //   126: aload_1
    //   127: invokevirtual getParameters : ()Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObject;
    //   130: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/DERSequence
    //   133: dup
    //   134: astore_3
    //   135: iconst_0
    //   136: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   139: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/DERInteger
    //   142: invokevirtual getValue : ()Ljava/math/BigInteger;
    //   145: invokevirtual intValue : ()I
    //   148: istore #4
    //   150: aload_3
    //   151: iconst_1
    //   152: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   155: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/DERObjectIdentifier
    //   158: astore #5
    //   160: iconst_0
    //   161: istore_1
    //   162: iconst_0
    //   163: istore #6
    //   165: iconst_0
    //   166: istore #7
    //   168: aload #5
    //   170: getstatic com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9Curve.tpBasis : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1ObjectIdentifier;
    //   173: invokevirtual equals : (Ljava/lang/Object;)Z
    //   176: ifeq -> 198
    //   179: aload_3
    //   180: iconst_2
    //   181: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   184: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/DERInteger
    //   187: invokevirtual getValue : ()Ljava/math/BigInteger;
    //   190: invokevirtual intValue : ()I
    //   193: istore_1
    //   194: goto -> 257
    //   197: iconst_0
    //   198: aload_3
    //   199: iconst_2
    //   200: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   203: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/DERSequence
    //   206: dup
    //   207: astore #5
    //   209: iconst_0
    //   210: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   213: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/DERInteger
    //   216: invokevirtual getValue : ()Ljava/math/BigInteger;
    //   219: invokevirtual intValue : ()I
    //   222: istore_1
    //   223: aload #5
    //   225: iconst_1
    //   226: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   229: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/DERInteger
    //   232: invokevirtual getValue : ()Ljava/math/BigInteger;
    //   235: invokevirtual intValue : ()I
    //   238: istore #6
    //   240: aload #5
    //   242: iconst_2
    //   243: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   246: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/DERInteger
    //   249: invokevirtual getValue : ()Ljava/math/BigInteger;
    //   252: invokevirtual intValue : ()I
    //   255: istore #7
    //   257: new com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9FieldElement
    //   260: dup
    //   261: iload #4
    //   263: iload_1
    //   264: iload #6
    //   266: iload #7
    //   268: aload_2
    //   269: iconst_0
    //   270: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   273: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/ASN1OctetString
    //   276: invokespecial <init> : (IIIILcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1OctetString;)V
    //   279: astore #5
    //   281: new com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9FieldElement
    //   284: dup
    //   285: iload #4
    //   287: iload_1
    //   288: iload #6
    //   290: iload #7
    //   292: aload_2
    //   293: iconst_1
    //   294: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   297: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/ASN1OctetString
    //   300: invokespecial <init> : (IIIILcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1OctetString;)V
    //   303: astore_3
    //   304: aload_0
    //   305: new com/jxdinfo/hussar/core/bouncycastle/math/ec/ECCurve$F2m
    //   308: dup
    //   309: iload #4
    //   311: iload_1
    //   312: iload #6
    //   314: iload #7
    //   316: aload #5
    //   318: invokevirtual getValue : ()Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   321: invokevirtual toBigInteger : ()Ljava/math/BigInteger;
    //   324: aload_3
    //   325: invokevirtual getValue : ()Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   328: invokevirtual toBigInteger : ()Ljava/math/BigInteger;
    //   331: invokespecial <init> : (IIIILjava/math/BigInteger;Ljava/math/BigInteger;)V
    //   334: putfield finally : Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECCurve;
    //   337: aload_2
    //   338: invokevirtual size : ()I
    //   341: iconst_3
    //   342: if_icmpne -> 360
    //   345: aload_0
    //   346: aload_2
    //   347: iconst_2
    //   348: invokevirtual getObjectAt : (I)Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;
    //   351: checkcast com/jxdinfo/hussar/core/bouncycastle/asn1/DERBitString
    //   354: invokevirtual getBytes : ()[B
    //   357: putfield C : [B
    //   360: return
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	361	0	a	Lcom/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9Curve;
    //   0	361	1	a	Lcom/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9FieldID;
    //   0	361	2	a	Lcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1Sequence;
  }
  
  public ECCurve getCurve() {
    return this.finally;
  }
  
  public DERObject toASN1Object() {
    // Byte code:
    //   0: new com/jxdinfo/hussar/core/bouncycastle/asn1/ASN1EncodableVector
    //   3: dup
    //   4: invokespecial <init> : ()V
    //   7: astore_1
    //   8: aload_0
    //   9: getfield e : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObjectIdentifier;
    //   12: getstatic com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9Curve.prime_field : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1ObjectIdentifier;
    //   15: invokevirtual equals : (Ljava/lang/Object;)Z
    //   18: ifeq -> 71
    //   21: aload_0
    //   22: new com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9FieldElement
    //   25: aload_1
    //   26: dup_x1
    //   27: dup_x2
    //   28: dup
    //   29: pop2
    //   30: dup
    //   31: aload_0
    //   32: getfield finally : Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECCurve;
    //   35: invokevirtual getA : ()Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   38: invokespecial <init> : (Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;)V
    //   41: invokevirtual getDERObject : ()Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObject;
    //   44: invokevirtual add : (Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;)V
    //   47: new com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9FieldElement
    //   50: dup
    //   51: aload_0
    //   52: getfield finally : Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECCurve;
    //   55: invokevirtual getB : ()Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   58: invokespecial <init> : (Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;)V
    //   61: invokevirtual getDERObject : ()Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObject;
    //   64: invokevirtual add : (Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;)V
    //   67: goto -> 127
    //   70: pop
    //   71: aload_0
    //   72: getfield e : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObjectIdentifier;
    //   75: getstatic com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9Curve.characteristic_two_field : Lcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1ObjectIdentifier;
    //   78: invokevirtual equals : (Ljava/lang/Object;)Z
    //   81: ifeq -> 126
    //   84: aload_1
    //   85: dup
    //   86: new com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9FieldElement
    //   89: dup
    //   90: aload_0
    //   91: getfield finally : Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECCurve;
    //   94: invokevirtual getA : ()Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   97: invokespecial <init> : (Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;)V
    //   100: invokevirtual getDERObject : ()Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObject;
    //   103: invokevirtual add : (Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;)V
    //   106: new com/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9FieldElement
    //   109: dup
    //   110: aload_0
    //   111: getfield finally : Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECCurve;
    //   114: invokevirtual getB : ()Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   117: invokespecial <init> : (Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;)V
    //   120: invokevirtual getDERObject : ()Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DERObject;
    //   123: invokevirtual add : (Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;)V
    //   126: aload_0
    //   127: getfield C : [B
    //   130: ifnull -> 148
    //   133: aload_1
    //   134: new com/jxdinfo/hussar/core/bouncycastle/asn1/DERBitString
    //   137: dup
    //   138: aload_0
    //   139: getfield C : [B
    //   142: invokespecial <init> : ([B)V
    //   145: invokevirtual add : (Lcom/jxdinfo/hussar/core/bouncycastle/asn1/DEREncodable;)V
    //   148: new com/jxdinfo/hussar/core/bouncycastle/asn1/DERSequence
    //   151: dup
    //   152: aload_1
    //   153: invokespecial <init> : (Lcom/jxdinfo/hussar/core/bouncycastle/asn1/ASN1EncodableVector;)V
    //   156: areturn
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	157	0	a	Lcom/jxdinfo/hussar/core/bouncycastle/asn1/x9/X9Curve;
  }
  
  public X9Curve(ECCurve eCCurve) {
    this.finally = eCCurve;
    this.C = null;
    const();
  }
  
  public X9Curve(ECCurve eCCurve, byte[] arrayOfByte) {
    this.finally = eCCurve;
    this.C = arrayOfByte;
    const();
  }
  
  public byte[] getSeed() {
    return this.C;
  }
}
